#!/usr/bin/perl -w
#
# updates the contact list for everybuddy
#
# Ben Rigas <ben@everybuddy.com>
#
#	* Now fixes empty group problem * 
#
#############################################################################

use strict;

### path to account file

my $path = $ENV{"HOME"} || $ENV{'LOGDIR'} ||
	(getpwuid($<))[7];

my $filename = "contacts";

### if old accounts file doesn't exist, ignore
-f "$path/$filename" or exit 0;

### read lines from old account file

open (OLD, "$path/$filename") 
   or die "Cant open old contact file: $!\n";

my @old = <OLD>;

close (OLD);

### Check to see if account file is already updated

! @old && exit 0;

$old[0] =~ /^<GROUP/ && exit 0;
# this is old news to most

### Make backup of account file

open (BACKUP, ">$path/$filename-backup")
   or die "Can't write backup file: $!\n";

print BACKUP @old;

close (BACKUP);

### Open file for writing the new format 

chomp(@old);

open (FILE, ">$path/$filename")
   or die "Cant open new contact file: $!\n";

# loop through the whole file

my $i = 0;
while ($i < @old) {
   if ($old[$i] =~ /GROUP\s+(.*)/i) {

# print <GROUP> and NAME=thing we just got

      print FILE "<GROUP>\n   NAME=\"$1\"\n";
      $i++;

# increment lines, and loop through until the next group

      until ($old[$i] =~ /GROUP\s(.*)/i) {  

         if ($old[$i] eq "") { 
            print "Found empty group! Done!\n"; 
            print FILE "</GROUP>\n"; 
            exit; 
         }
 
# print Contact start and name, increment lines

         print FILE "   <CONTACT>\n      NAME=\"$old[$i]\"\n";
         $i++;

# print protocol, and skip two lines, ignoring the default chat thing

         print FILE "      DEFAULT_PROTOCOL=\"$old[$i]\"\n";
         $i = $i + 2;

# go through each account proto/name for each contact

         until ($old[$i] eq "END") {
            print FILE "      <ACCOUNT $old[$i]>\n";
            $i++;
            print FILE "         NAME=\"$old[$i]\"\n      </ACCOUNT>\n";
            $i++;
         }       
         print FILE "   </CONTACT>\n";

# catch the last line, so it doesnt get incremented and give us
# $i = $#old+1, that would screw everything up

         if ($i == $#old) {
            last;
#otherwise increment lines and go through group again
         } else {
            $i++;
         }
      }
      print FILE "</GROUP>\n"; 

   } else {
      $i++;
   }
}

close(FILE);
print "Conversion complete: $i contacts updated.\n";

